#include <iostream>

using namespace std;

int main()
{
    int N,K,i,j,g,h,f,J,I,br=0,Z;
    bool T,ima;
    cin>>N>>K;
    int A[N][N];
    for (i=0;i<N;i++)for(j=0;j<N;j++)cin>>A[i][j];
    for (g=1,T=false,ima=false;g<=K;g++){
            for (i=0;i<N && T==false;i++){
                    for(j=0;j<N && T==false;j++){
                            if(ima==true){if ((g==A[i][j] && (i>I || (i<=I && j>J)))||(g!=A[i][j] && i<=I && j<=J && j>=Z )){T=true;br--;}}
                            else if(g==A[i][j]){I=i;J=j;Z=j;for(h=j+1;h<=N;h++){if(g==A[i][h])J++;else break;}
                                           for(f=i+1;f<=N;f++){if(g==A[f][j])I++;else break;}
                                            ima=true;br++;
                                           }
                    }
            }
    T=false;ima=false;}
cout<<br;
    return 0;


}